// $Header: E:/RCS/start.js 1.32 2002/04/17 23:47:06 prupe Exp prupe $

// !!IMPORTANT!!  MAKE SURE YOU BYPASS PROXOMITRON WHEN DOWNLOADING THIS FILE.
// IT CONTAINS CODE THAT OTHER FILTERS MAY INADVERTENTLY REWRITE.

// Get the latest version of this file from
//   http://www.geocities.com/u82011729/prox/filter.html#tamescripts

// Javascript file for use with the "Tame Javascript" filter in Proxomitron.
// Place in your Proxomitron\html directory.  Mainly for illustrative purposes
// to show the kinds of things that are possible when you can use Javascript
// for your own purposes rather than being at the mercy of page authors all the
// time.  This code could very well break some sites, so look over it first.
// Feel free to e-mail me any comments or suggestions or post them to the
// Proxomitron mailing list at <http://groups.yahoo.com/group/prox-list/> so
// all can benefit.

// Set this flag until the very last line in end.js.
var pageIsLoadingPROX = 1;

// Some of these tricks don't work in IE.  Unfortunately there's no way to
// check for the features directly without causing errors, so we have to resort
// to browser-sniffing instead.
var isInternetExplorerPROX = (navigator.userAgent.indexOf('MSIE') != -1 &&
                              navigator.userAgent.indexOf('Opera') == -1);

// Disable window.open until the page is fully loaded.  end.js sets this back
// to 1 to enable pop-ups again.
var popupsAllowedPROX = 0;
var alertsAllowedPROX = 0;
var alertsLeftPROX = 10;

// Returns the domain portion of the given URL.  Probably not exactly right,
// but close enough.
function getDomainPROX(url)
{
  var a = url.indexOf('://');
  var b;
  var c;
  if (a == -1)
    return null;
  url = url.substr(a + 3);
  b = url.indexOf('/');
  if (b != -1)
    url = url.substr(0, b);
  b = url.indexOf('@');
  if (b != -1)
    url = url.substr(b);
  b = url.indexOf(':');
  if (b != -1)
    url = url.substr(0, b);
  for (a = 0, b = -1; ; )
  {
    a = url.indexOf('.', a + 1);
    if (a == -1)
    {
      break;
    }
    c = url.indexOf('.', a + 1);
    if (c == -1)
      break;
    b = a;
  }
  url = url.substr(b + 1);
  return url;
}

// Returns 1 if the given target refers to an existing frame or window, 0
// otherwise.
function checkLinkTargetPROX(t)
{
  var i, f;
  if (!t || t == '_top' || t == '_parent' || t == '_self')
    return 1;    // _top, _parent, and _self are ok.
  if (t == '_blank' || t == '_new' || t == 'blank' || t == 'new')
    return 0;    // Always reject _blank, etc.
  if (t.indexOf('google') == 0)
    return 1;    // For compatibility with the Google filter.
  for (i = 0, f = window.parent.frames; i < f.length; i++)
    if (t == f[i].name)
      return 1;  // If the target matches an existing frame, ok.
  return 0;      // Otherwise, no soup for you.
}

// Returns true if alert/confirm/prompt have not been called a bunch of times
// already, false if they have.  Used to stop runaway scripts abusing these
// pop-up functions.
function checkAlertPROX()
{
  // IE still can't override functions reliably.
  if (isInternetExplorerPROX)
    return false;
  if (!alertsAllowedPROX)
    return false;
  if (--alertsLeftPROX >= 0)
    return true;
  if (oldConfirmPROX('*** PROXOMITRON ALERT ***\r\nThis script is too busy for its own good.  Kill it?'))
  {
    alertsAllowedPROX = 0;
    return false;
  }
  else
  {
    return true;
  }
}

// My version of the open new window function.  Replaces open, window.open
// and other variants.  This version is a no-op if the domain of the pop-up
// window is different from that of the current site.
function openPROX(url, name, props)
{
  if (!popupsAllowedPROX ||
      (url.indexOf('://') != -1 &&
       getDomainPROX(url) != getDomainPROX(window.location.href)))
  {
    // Opera 6 is not happy with this document.write in some cases.
    if (pageIsLoadingPROX)
      document.writeln('<span class=prox kill=Popup detail=' +
                       url.substr(0, 20) + '></span>');
    return null;
  }
  else if (!isInternetExplorerPROX && (url == '' || checkLinkTargetPROX(name)))
  {
    // Allow the pop-up in this case, but always put full controls
    // (scrollbars, etc.) on the window.  Also ignore the caller's settings
    // for size and position to prevent offscreen/invisible pop-up windows.
    return oldOpenPROX(url, name, 'toolbar=1, scrollbars=1, location=1, status=1, menubar=1, resizable=1, width=500, height=500');
  }
  else
  {
    // Just go there directly instead of opening a new window.
    if (url != '')
      top.location = url;
    return null;
  }
}

// Override the alert function
function alertPROX(m)
{
  if (!checkAlertPROX())
    return null;
  return oldAlertPROX(m);
}

// Override the confirm function
function confirmPROX(m)
{
  if (!checkAlertPROX())
    return null;
  return oldConfirmPROX(m);
}

// Override the prompt function
function promptPROX(m, d)
{
  if (!checkAlertPROX())
    return null;
  if (!d)
    d = '';
  return oldPromptPROX(m, d);
}

// Intercept calls to *.location = or *.location.replace()
function setLocationPROX(l)
{
  if (pageIsLoadingPROX)
    document.write('<a class=proxlink target=_top href="' + l +
                   '">[Redirect]</a>');
  else
    top.location = l;
  return false;
}
location.replace = setLocationPROX;

// Replace a built-in function with a new version, preserving the old.  All
// four arguments to this function are strings.
// a - original function name
// b - variable under which to stash original function
// c - new implementation of function
// d - arglist to function
function replaceFunctionPROX(a, b, c, d)
{
  var s = '';
  var e = d.replace(/([a-zA-Z0-9]+)/g, '\'$1\'');
  s += 'var ' + b + ' = ' + a + ';';
  if (isInternetExplorerPROX)
    s += 'function ' + a + '(' + d + ')  { return ' + c + '(' + d + '); }';
  else
    s += a + ' = new Function(' + e + ', \'return ' + c + '(' + d + ');\');';
  s += 'window.' + a + ' = ' + c + ';'
  return s;
}

eval(replaceFunctionPROX('open', 'oldOpenPROX', 'openPROX', 'u, n, p'));
eval(replaceFunctionPROX('alert', 'oldAlertPROX', 'alertPROX', 'm'));
eval(replaceFunctionPROX('confirm', 'oldConfirmPROX', 'confirmPROX', 'm'));
eval(replaceFunctionPROX('prompt', 'oldPromptPROX', 'promptPROX', 'm, d'));

// Forcibly reduces the given function name to a no-op.
function crippleFunctionPROX(f)
{
  if (isInternetExplorerPROX)
    eval('function ' + f + '()  { return true; }');
  else
    eval(f + ' = new Function("return true;");');
  eval('window.' + f + ' = ' + f + ';');
  eval('window.parent.' + f + ' = ' + f + ';');
  eval('window.top.' + f + ' = ' + f + ';');
  eval('document.' + f + ' = ' + f + ';');
  if (document.body)
    eval('document.body.' + f + ' = ' + f + ';');
  eval('self.' + f + ' = ' + f + ';');
  eval('this.' + f + ' = ' + f + ';');
}

// Override some window manipulation APIs (which never should have existed in
// first place).
crippleFunctionPROX('resizeTo');
crippleFunctionPROX('resizeBy');
crippleFunctionPROX('moveTo');
crippleFunctionPROX('moveBy');
crippleFunctionPROX('scrollTo');
crippleFunctionPROX('scrollBy');
crippleFunctionPROX('blur');
crippleFunctionPROX('focus');
crippleFunctionPROX('setInterval');
crippleFunctionPROX('setTimeout');
crippleFunctionPROX('captureEvents');
crippleFunctionPROX('close');

// Override some window properties as well.  crippleFunction won't work with
// these, so do it this way instead.
function status()         { return true; }
function defaultStatus()  { return true; }

// Provide definitions for common ad script functions that get filtered out
// and cause subsequent errors.
function geovisit()       { return true; }

// Set the referrer for this page to http://currenthost/ or fakeReferrer if
// available.  This makes it consistent with the "Fake referrer info" filter.
// Note that this (and just about everything that follows) does not work on IE.
if (!isInternetExplorerPROX)
  if (document.fakeReferrer)
    document.referrer = document.fakeReferrer;
  else
    document.referrer = window.location.protocol + '//' +
                        window.location.hostname + '/';

// Set window history to empty.
if (!isInternetExplorerPROX)
  history = new Array();

// Override these history methods.
function go(n)               { return true; }
function back()              { return true; }
function forward()           { return true; }
if (!isInternetExplorerPROX)
{
  history.go      = go;
  history.back    = back;
  history.forward = forward;
}

// Hide plugins from nosy scripts.  This could cause problems with sites that
// check if you have Flash before attempting to use it.
if (!isInternetExplorerPROX)
  navigator.plugins = new Array;

// Set various none-of-your-damn-business screen metrics to random numbers.
if (!isInternetExplorerPROX)
{
  screen.availHeight = 10000.0 * Math.random();
  screen.availWidth = 10000.0 * Math.random();
  screen.outerHeight = 10000.0 * Math.random();
  screen.outerWidth = 10000.0 * Math.random();
  screen.colorDepth = 10000.0 * Math.random();
  screen.height = 10000.0 * Math.random();
  screen.width = 10000.0 * Math.random();
  screen.pixelDepth = 10000.0 * Math.random();

  window.screen.availHeight = 10000.0 * Math.random();
  window.screen.availWidth = 10000.0 * Math.random();
  window.screen.outerHeight = 10000.0 * Math.random();
  window.screen.outerWidth = 10000.0 * Math.random();
  window.screen.colorDepth = 10000.0 * Math.random();
  window.screen.height = 10000.0 * Math.random();
  window.screen.width = 10000.0 * Math.random();
  window.screen.pixelDepth = 10000.0 * Math.random();
}
