// $Header: E:/RCS/pageedit.js 1.8 2002/01/20 16:30:49 prupe Exp prupe $

// !!IMPORTANT!!  MAKE SURE YOU BYPASS PROXOMITRON WHEN DOWNLOADING THIS FILE.
// IT CONTAINS CODE THAT OTHER FILTERS MAY INADVERTENTLY REWRITE.

// Get the latest version of this file from
//   http://www.geocities.com/u82011729/prox/pageedit.js

/****************************************************************************

 Javascript file for use with the "Page editor toolbar" filter in Proxomitron.
 This is an experimental script used to demonstrate editing an HTML document on
 the fly in your browser.  Place the file in your Proxomitron\html directory
 and activate the web filter below.  If you are using other <end> filters that
 add Javascript to a page (such as my Tame Javascript filter), you may need to
 put this one after them in the web filters list.  Note that the filter is
 disabled for Opera, but the toolbar is mostly non-functional there anyway.

 Name = "Page editor toolbar"
 Active = TRUE
 URL = "$TYPE(htm)$OHDR(User-Agent:(^*Opera))"
 Limit = 256
 Match = "<end>"
 Replace = "\r\n<!--//-->"
           "<script type="text/javascript" "
           "src="http://local.ptron/pageedit.js"></script>"

 Usage: Double-click on any table-cell (TD) or division (DIV), basically any
 "block" element on the page.  The element will be highlighted by a dotted red
 border and the selected element should appear in the text field below.  From
 there you can do several things:
   1. Select a property from the drop-down menu and enter a new value in the
      box next to it and click Change.  You can modify the object's width,
      font size, background color, text color, and other properties this way.
   2. Select Hide/Show to change the object's visibility property (equivalent
      to choosing 'visibility' and entering hidden/show respectively).
   3. Select Delete/Undelete to remove the object completely or put it back
      (equivalent to choosing 'display' and entering none/block respectively).
   4. Navigate to other elements using the Parent, Children, and Next/Prev
      sibling buttons.  Or Clear the selected element entirely.  You can get to
      previously deleted elements this way.
 Obviously there are a lot more properties one could set as well.

 Limitations: This won't work in Opera as of version 6 due to insufficient DOM
 (Document Object Model) support.  It does work well in Internet Explorer 6.
 In theory it should work in Mozilla, but doesn't for some reason I haven't
 figured out yet (maybe ondblclick doesn't work?).

 ***************************************************************************/

var toolbarHTMLPROX = '                                                     \
<div class="proxtoolbar"                                                    \
  style="text-align: center; color: white; background-color: green;">       \
<form id="proxpageedit">                                                    \
Property: <select name="property">                                          \
<option selected value="width">Width</option>                               \
<option value="color">Color</option>                                        \
<option value="backgroundColor">Background color</option>                   \
<option value="fontSize">Font size</option>                                 \
<option value="display">Display</option>                                    \
<option value="visibility">Visibility</option>                              \
</select>                                                                   \
Value: <input type="text" name="value" value="" size=10>                    \
<input type="button" onclick="changeItPROX()" value="Change">               \
<br>                                                                        \
Selected: <input type="text" name="tag" value="" size=25 readonly>          \
<br>                                                                        \
<input type="button" onclick="changeItPROX(\'visibility\', \'hidden\')"     \
  value="Hide">                                                             \
<input type="button" onclick="changeItPROX(\'visibility\', \'visible\')"    \
  value="Show">                                                             \
<input type="button" onclick="changeItPROX(\'display\', \'none\')"          \
  value="Delete">                                                           \
<input type="button" onclick="changeItPROX(\'display\', \'block\')"         \
  value="Undelete">                                                         \
<br>                                                                        \
<input type="button" onclick="moveItPROX(1)" value="Parent">                \
<br>                                                                        \
<input type="button" onclick="moveItPROX(2)" value="Prev sibling">          \
<input type="button" onclick="moveItPROX(3)" value="Next sibling">          \
<br>                                                                        \
<input type="button" onclick="moveItPROX(4)" value="Children">              \
<br>                                                                        \
<input type="button" onclick="moveItPROX(5)" value="Clear">                 \
</form>                                                                     \
</div>                                                                      \
';
var selPROX = null;
var formPROX = null;

function setItPROX(e)
{
  var f = formPROX.elements[3];
  if (selPROX && selPROX.style)
    selPROX.style.border = 'none';
  if (!e || e.id == 'proxpageedit')
  {
    selPROX = null;
  }
  else
  {
    selPROX = e;
    if (selPROX.style)
      selPROX.style.border = 'thin dotted red';
  }
  if (selPROX)
  {
    if (selPROX.tagName)
      f.value = selPROX.tagName.toLowerCase();
    else
      f.value = 'text';
    if (selPROX.id)
      f.value += ' (#' + selPROX.id + ')';
    if (selPROX.getAttribute && selPROX.getAttribute('class'))
      f.value += ' (.' + selPROX.getAttribute('class') + ')';
    if (selPROX.style && selPROX.style.visibility == 'hidden')
      f.value += ' (hidden)';
    if (selPROX.style && selPROX.style.display == 'none')
      f.value += ' (deleted)';
  }
  else
  {
    f.value = '';
  }
}

function moveItPROX(n)
{
  var old = selPROX;
  if (!selPROX)
    return;
  if (n == 1)
    setItPROX(selPROX.parentNode);
  else if (n == 2)
    setItPROX(selPROX.previousSibling);
  else if (n == 3)
    setItPROX(selPROX.nextSibling);
  else if (n == 4)
    setItPROX(selPROX.firstChild);
  else if (n == 5)
    setItPROX(null);
  if (n != 5 && !selPROX)
    setItPROX(old);
}

function changeItPROX(p, v)
{
  var s = formPROX.elements[0];

  if (!selPROX || !selPROX.style)
    return;
  if (!p)
    p = s.options[s.selectedIndex].value;
  if (!v)
    v = formPROX.elements[1].value;
  eval('selPROX.style.' + p + ' = v');
  setItPROX(selPROX);
}

function highlightItPROX()
{
  setItPROX(this);
}

function walkElemPROX(b, n)
{
  var a;
  if (!n || !n.style)
    return;
  b.push(n);
  for (a = n.firstChild; a; a = a.nextSibling)
    walkElemPROX(b, a);
}

function initPageEditPROX()
{
  var b, i;

  document.writeln(toolbarHTMLPROX);
  toolbarHTMLPROX = null;
  formPROX = document.getElementById('proxpageedit');
  if (formPROX)
  {
    b = new Array();
    walkElemPROX(b, document.body);
    for (i = 0; i < b.length; i++)
      if (b[i].tagName == 'TD' || // b[i].tagName == 'TABLE' ||
          b[i].tagName == 'DIV')
        b[i].ondblclick = highlightItPROX;
    /*
    for (i = 0; i < b.length; i++)
    {
      a = b[i].parentNode;
      if (b[i].ondblclick == highlightItPROX)
        for (; a; a = a.parentNode)
          a.ondblclick = null;
    }
    */
    setItPROX(null);
  }
}

initPageEditPROX();
